-- Criado por EAJS

-- Mod para SRB2: Encolher jogadores em 20% e permitir spawnar molas com os botões CUSTOM1, CUSTOM2 e CUSTOM3

local springCooldown = {} -- Tabela para armazenar cooldowns individuais de cada jogador

-- Hook para encolher o jogador em 20% ao spawnar
addHook("PlayerSpawn", function(player)
    if player and player.mo then
        player.mo.scale = FRACUNIT * 2 / 10 -- 20% do tamanho original
    end
end)

-- Hook para spawnar molas ao pressionar os botões customizados
addHook("PlayerThink", function(player)
    if not (player and player.mo) then return end
    local mo = player.mo

    -- Inicializa cooldown do jogador, se ainda não existir
    if not springCooldown[player] then
        springCooldown[player] = 0
    end

    -- Verifica se o jogador está completamente parado (sem movimento horizontal e vertical) e se o cooldown já passou
    if mo.momx == 0 and mo.momy == 0 and mo.momz == 0 and (springCooldown[player] <= 0) then
        -- Spawn de mola azul (grátis) - Botão CUSTOM1
        if (player.cmd.buttons & BT_CUSTOM1) ~= 0 then
            P_SpawnMobj(mo.x, mo.y, mo.z, MT_BLUESPRING)
            springCooldown[player] = 35 -- Define cooldown de 1 segundo
        end

        -- Spawn de mola amarela (custa 10 anéis) - Botão CUSTOM2
        if (player.cmd.buttons & BT_CUSTOM2) ~= 0 and player.rings >= 5 then
            P_SpawnMobj(mo.x, mo.y, mo.z, MT_YELLOWSPRING)
            player.rings = player.rings - 5 -- Gasta os 5 anéis
            springCooldown[player] = 35 -- Define cooldown de 1 segundo
        end

        -- Spawn de mola vermelha (custa 50 anéis) - Botão CUSTOM3
        if (player.cmd.buttons & BT_CUSTOM3) ~= 0 and player.rings >= 25 then
            P_SpawnMobj(mo.x, mo.y, mo.z, MT_REDSPRING)
            player.rings = player.rings - 25 -- Gasta os 25 anéis
            springCooldown[player] = 35 -- Define cooldown de 1 segundo
        end
    end

    -- Reduz o cooldown a cada tic
    if springCooldown[player] > 0 then
        springCooldown[player] = $ - 1
    end
end)
